{$A+,B-,F+,G+,N+,P+,Q-,R-,T-,V+,X+,I-}
{****************************************************************************
 * SoundLib 2 Mixing demo - (c) 2000-2001 by Stefan Goehler                 *
 * Shows how to play music and samples at once, shows usage of Dolby Pro    *
 * Logic support                                                            *
 * Copyright agreement in soundlib.txt - illegal copy without this file!    *
 * Complete package and new version always available here:                  *
 * http://sourcenet.home.pages.de                                           *
 * ---                                                                      *
 *                                                                          *
 * Warning: direct disk playback doesn't work under FPC!                    *
 *          ANY HELP TO FIX THIS APPRECIATED!!                              *
 ****************************************************************************}
{$IFNDEF FPC}
uses sndlib2,newfrontier,crt,stream32,snd_fmt,drv_sb,drv_sil,snd_mod,timebase;
{$ELSE}
{$ASMMODE INTEL}
uses sndlib2,crt,snd_fmt,drv_sb,drv_sil,snd_mod,objects,timebase;
{$ENDIF}
const
  maxcount  = 5;
  precision = 1;

var
  sound   : psound;
  {$IFNDEF FPC}
  s       : tfilestream32;
  {$ELSE}
  s       : tdosstream;
  {$ENDIF}
  timer   : pztimer;
  sb      : psoundblaster;
  silent  : psilent;
  driver  : psounddriver;

  modf    : pmod;
  snd     : array[0..2] of tsample;
  wave    : pwave;
  c       : char;
  i       : longint;
  oldmem  : longint;
  vol     : word;
  intpol  : boolean;
  cap     : tcardinfo;
  lasttime: comp;
  nexttime: comp;
  count   : array[0..maxcount-1] of longint;
  first   : boolean;

procedure waitretrace;assembler;
{waits until kathod-beam runs to the top of the screen}
asm
  mov   dx,03DAh
  @lp1:
    in    al,dx
    test  al,8
  jz   @lp1
  @lp2:
    in    al,dx
    test  al,8
  jnz   @lp2
end;

procedure error(s : string);
begin
  writeln(s);
  halt;
end;

begin
  oldmem := memavail;

  { Initialize sound driver }
  new(sb,init(0));
  if (sb = nil)or(not sb^.startplayback(0,snd_auto+snd_prologic))
  then
  begin
    { Init silent driver with no interrupt calls }
    new(silent,init(false));
    silent^.startplayback(0,snd_auto+snd_prologic);
    writeln('Soundblaster driver initialization failed, using silent driver');
    driver := silent;
  end
  else driver := sb;

  { Initialize sound object }
  new(sound,init(driver^,2));

  { Load MODule music file }
  if not s.init('sounds\cd2part2.mod',stopenread) then
  error('MODule file not found');

  new(modf,init(driver^,s));
  if (modf = nil) then
  error('MODule file loader error');
  s.done;
  { Set MODule volume lower to hear other sounds better }
  modf^.setvolume(0,128);
  modf^.setvolume(1,128);
  modf^.play; { Start playback }

  { Load first wave file }
  if not s.init('sounds\chimes.wav',stopenread) then
  error('WAVe file not found');
  new(wave,init(sound^,s));
  if (wave = nil) then
  error('WAVe file loader error');
  snd[0].init(sound^,wave^);

  { Set the sound position to 0 (middle) and -256 (far behind) at volume 256 }
  snd[0].setsoundpos(0,-256,256);
  wave^.free;
  s.done;

  { Load next wave file  }
  if not s.init('sounds\chord.wav',stopenread) then
  error('WAVe file not found');
  new(wave,init(sound^,s));
  if (wave = nil) then
  error('WAVe file loader error');
  snd[1].init(sound^,wave^);

{ ***
  You can uncomment this, 'cause it's not necessary as the file is already
  loaded. It's just here for better understanding of the code              }
  wave^.free;
  s.done;
  if not s.init('sounds\chord.wav',stopenread) then halt;
  new(wave,init(sound^,s));
{ *** }

  driver^.getcapabilities(cap);
  { Put out some information }
  clrscr;
  writeln('If you have a Dolby Pro Logic capable amplifier, please');
  writeln('turn on the Pro Logic mode to hear surround the right way');
  writeln;
  writeln('Initialized output: '+cap.cardstring);
  writeln;
  writeln('Available buttons:');
  writeln;
  writeln('[1] Play sound 1 (is on surround channel)');
  writeln('[2] Play sound 2');
  writeln('[3] Play sound 2 directly from disk');
  writeln('[4] Pause MOD music playback');
  writeln('[I] Toggle sample interpolation');
  writeln;
  writeln('[-/+] Adjust music playback volume');
  writeln;

  { Initialize all things }
  new(timer,init);
  timer^.start;
  lasttime := 0;
  nexttime := timer^.lap+precision/timer^.resolution;
  first    := true;
  count[maxcount-1] := 0;

  vol := 128;

  { Main program loop }
  repeat
    waitretrace;
    inc(count[maxcount-1]);

    if keypressed then c := readkey else c := #1;
    case upcase(c) of
      '1' : snd[0].play;
      '2' : snd[1].play;
      '3' : wave^.play;
      '4' : modf^.pause;
      '-','+': begin
                 if (c = '-')and(vol > 3) then dec(vol,4);
                 if (c = '+')and(vol < 253) then inc(vol,4);
                 modf^.setvolume(0,vol);
                 modf^.setvolume(1,vol);
               end;
      'I' : begin
              intpol := not intpol;
              sound^.setinterpolation(intpol);
              modf^.setinterpolation(intpol);
            end;
    end;
    if (timer^.lap >= nexttime) then
    begin
      if (count[maxcount-1] > 70) then count[maxcount-1] := 70;
      nexttime := timer^.lap;
      if (first) then
      begin
        for i := 0 to maxcount-2 do count[i] := count[maxcount-1];
        first := false;
      end;
      for i := 1 to maxcount-1 do inc(count[0],count[i]);
      write(#13'Used CPU-time: ',
            100-100*((count[0]/maxcount*1/precision)/(70)):4:2,
            '% ');
      nexttime := nexttime+precision/timer^.resolution;
      for i := 0 to maxcount-2 do count[i] := count[i+1];
      count[maxcount-1] := 0;
    end;

  until (c = #27);
  { Catch all pressed keys }
  while keypressed do readkey;
  writeln;
  dispose(timer,done);

  { Close all sounds }
  for i := 0 to 1 do snd[i].done;
  wave^.free;
  { Close WAVe file which has been played from disk }
  s.done;

  { Close sound objects }
  sound^.free;
  modf^.free;

  { Deinitialize sound driver }
  driver^.stopplayback;
  driver^.free;

  writeln('Left memory: ',oldmem-memavail,' bytes');
end.
