{$A+,B-,F+,G+,N+,E-,P+,Q-,R-,T-,V+,X+}
{****************************************************************************
 * SoundLib 2 Wave player - copyright (c) 1997-2001 by Stefan Goehler       *
 * Copyright agreement in soundlib.txt - illegal copy without this file!    *
 * Any bug reports and suggestions are welcome                              *
 * Complete package and new version always available here:                  *
 * http://sourcenet.home.pages.de                                           *
 * ---                                                                      *
 *                                                                          *
 * Warning: due some current limitations, some of the features may not work *
 *          in every circumstance. The VU meter does only work with mono    *
 *          files, the sample interpolation isn't supported yet.            *
 *          The player does yet not work with FPC. ANY HELP APPRECIATED!!   *
 ****************************************************************************}

{$IFNDEF FPC}
uses crt,sndlib2,drv_sb,drv_sil,snd_fmt,ports,stream32;
{$ELSE}
uses crt,sndlib2,drv_sb,drv_sil,snd_fmt,ports,objects,go32;
{$ENDIF}

var
  i         : integer;
  tc,bc     : byte;
  st        : string[39];

  sound     : psound;
  wav       : pwave;
  voc       : pvoc;
  wave      : psounddat;
  sb        : psoundblaster;
  silent    : psilent;
  driver    : psounddriver;
  vol       : word;
  pos,pos2  : longint;
  ch,lch    : char;
  {$IFNDEF FPC}
  s         : tfilestream32;
  {$ELSE}
  s         : tdosstream;
  {$ENDIF}
  speed     : double;

  cap       : tcardinfo;
  intpol    : boolean;
  mute      : boolean;

{ Character set bitmaps }
const
  led1  : array[0..15] of byte=(0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0);
  led2  : array[0..15] of byte=(0,0,0,0,144,144,144,144,144,144,144,144,0,0,0,0);
  led3  : array[0..15] of byte=(0,0,0,0,146,146,146,146,146,146,146,146,0,0,0,0);
  char1 : array[0..15] of byte=(0,0,0,0,170,0,170,0,170,0,170,0,170,0,170,0);
  char2 : array[0..15] of byte=(0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,0);
  lo     : array[0..15] of byte=(255,255,192,192,192,192,192,192,192,192,192,192,192,192,192,192);
  ro     : array[0..15] of byte=(255,255,3,3,3,3,3,3,3,3,3,3,3,3,3,3);
  o      : array[0..15] of byte=(255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
  so     : array[0..15] of byte=(255,255,24,24,24,24,24,24,24,24,24,24,24,24,24,24);
  s1     : array[0..15] of byte=(24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24);
  lu     : array[0..15] of byte=(192,192,192,192,192,192,192,192,192,192,192,192,192,192,255,255);
  ru     : array[0..15] of byte=(3,3,3,3,3,3,3,3,3,3,3,3,3,3,255,255);
  u      : array[0..15] of byte=(0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255);
  su     : array[0..15] of byte=(24,24,24,24,24,24,24,24,24,24,24,24,24,24,255,255);
  sr     : array[0..15] of byte=(3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3);
  sl     : array[0..15] of byte=(192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192);



procedure TextColor(Color: Byte);
begin
  tc := color;
  crt.textcolor(color);
end;

procedure TextBackground(Color: Byte);
begin
  bc := color;
  crt.textbackground(color);
end;

procedure writexy(x,y : integer;s : string);
var
  i : integer;
  color : word;
begin
  color := (tc+bc shl 4) shl 8;
  dec(x,2);dec(y);
  for i := 1 to length(s) do memw[segB800:(y*80+x)*2+i*2] := ord(s[i])+color;
end;

procedure frame(x,y,sx,sy : integer);
const
  frames : array[1..9] of char = ('','','','','','','','','');
var
  lx,ly : integer;
  s : string;
begin
  textcolor(white);
  textbackground(blue);
  s := frames[1];
  for lx := 1 to sx-2 do s := s + frames[5];
  s := s + frames[2];
  gotoxy(x,y);
  write(s);
  for ly := 1 to sy-2 do begin
    s := frames[7];
    for lx := 1 to sx-2 do s := s + ' ';
    s := s + frames[8];
    gotoxy(x,y+ly);
    write(s);
    textcolor(lightgray);
    textbackground(black);
    write('');
    textbackground(blue);
    textcolor(white);
  end;
  s := frames[4];
  for lx := 1 to sx-2 do s := s + frames[9];
  s := s + frames[3];
  gotoxy(x,y+sy-1);
  write(s);
  s := '';
  textcolor(lightgray);
  textbackground(black);
  write('');
  for lx := 1 to sx do s := s + '';
  gotoxy(x+2,y+sy);
  write(s);
  textbackground(blue);
end;

procedure cls;
begin
  textbackground(blue);
  textcolor(blue);
  clrscr;
  textcolor(white);
  textbackground(lightgray);
  gotoxy(1,2);
  write('');
  textcolor(lightgray);
  textbackground(black);
  write('');textcolor(lightgray);
  textcolor(white);
  textbackground(lightgray);
  gotoxy(1,3);
  for i := 1 to 22 do write('');
  textcolor(white);
  textbackground(blue);
  writexy(4,1,'Waveplayer, (c) 2001 by Stefan Ghler, Germany - uses '+sound^.getversionstring);
end;

procedure hidecursor;
begin
  gotoxy(1,1);
end;

procedure setchar(ch : char;var data);
begin
  outpw($03c4,$0402);
  outpw($03c4,$0704);
  outpw($03ce,$0204);
  outpw($03ce,$0005);
  outpw($03ce,$0006);
  {$IFNDEF FPC}
  move(data,ptr(segA000,ord(ch) shl 5)^,16);
  {$ELSE}
  dosmemput(segA000,ord(ch) shl 5,data,16);
  {$ENDIF}
  outpw($03c4,$0302);
  outpw($03c4,$0304);
  outpw($03ce,$0004);
  outpw($03ce,$1005);
  outpw($03ce,$0e06);
end;

procedure vumeter;

procedure showvu(x,y,size : word);
var
  i : integer;
  s : string;

begin
  s := '';
  textcolor(lightcyan);
  textbackground(black);
  fillchar(s[1],21,32);
  fillchar(s[1],size div 3,'');
  case size mod 3 of
    1 : s[size div 3+1] := '';
    2 : s[size div 3+1] := '';
  end;
  s[0] := #17;
  writexy(x,y,s);
  textcolor(lightred);
  s[0] := #20;
  delete(s,1,17);
  writexy(x+17,y,s);
end;

var
  vol : word;

begin
  vol := wave^.getvu;

  textbackground(black);
  showvu(10,19,vol);
  showvu(10,20,vol);
  textcolor(white);
  textbackground(blue);
end;

function inttostr(l,width : longint) : string;
{ convert longint to string }
var
  c : string[20];
begin
  str(l,c);
  for i := 1 to width-length(c) do c := '0'+c;
  inttostr := c;
end;

function flttostr(l : double;f1,f2 : byte) : string;
{ convert double to string with string formatting }
var
  c : string[20];
begin
  str(l:f1:f2,c);
  flttostr := c;
end;


procedure showinfo;
begin
  textcolor(white);
  pos := wave^.getpos;
  pos2 := pos*wave^.data.samplesize;
  pos := pos div longint(wave^.data.ofreq);
  writexy(37,19,'Time    : '+inttostr(pos div 60,2)+':'+inttostr(pos mod 60,2));
  writexy(37,20,'Position: '+inttostr(pos2 div 1024,5)+' KB');
  st := '';
  for i := 1 to round(wave^.getpos/wave^.getsize*39)  do st := st+'';
  for i := round(wave^.getpos/wave^.getsize*39) to 38 do st := st+'';
  writexy(37,21,st);
  writexy(36,10,'Speed     : '+flttostr(speed*100,3,1)+'% ');
  if (vol > 256) then st := ' (amplified)' else st := '            ';
  writexy(36,11,'Volume    : '+inttostr(vol,3)+st);
  vumeter;
end;

begin
  {$IFDEF FPC}
  writeln('Warning: This demo will probably not work under FPC. Reading directly');
  writeln('         from disk doesn''t work - any help appreciated');
  writeln;
  writeln('Press any key to continue...');
  readkey;
  {$ENDIF}

  { Check commandline parameters }
  if (paramcount = 0) then
  begin
    writeln('SoundLib 2 wave player; (c) 2001 by Stefan Goehler');
    writeln;
    writeln('Usage: WAVEPLAY [FILE]');
    writeln('FILE : WAV or VOCfile');
    exit;
  end;

  { Initialize sound driver }
  new(sb,init(2048));
  if (sb = nil)or(not sb^.startplayback(0,snd_auto)) then
  begin
    { Init silent driver WITH interrupt calls }
    new(silent,init(true));
    silent^.startplayback(0,snd_auto);
    writeln('Soundblaster driver initialization failed, using silent driver');
    writeln('You won''t hear any sound, you''ll just see the displayment');
    writeln;
    writeln('Press any key to continue...');
    readkey;
    driver := silent;
  end
  else driver := sb;

  { Initialize sound object }
  new(sound,init(driver^,1));

  if not s.init(paramstr(1),stopenread) then
  begin
    writeln('SoundLib 2 Wave file player; (c) 2000-2001 by Stefan Goehler');
    writeln;
    writeln('Error while opening file: ',paramstr(1));
    sound^.free;
    driver^.free;
    halt;
  end;

  new(wav,init(sound^,s));
  if (wav = nil) then
  begin
    new(voc,init(sound^,s));
    wave := voc;
  end else wave := wav;

  { If no supported file type found, exit }
  if (wave = nil) then
  begin
    writeln('SoundLib 2 Wave file player; (c) 2000-2001 by Stefan Goehler');
    writeln;
    writeln('File seems to be no valid WAVe or VOC file');
    sound^.free;
    driver^.free;
    halt;
  end;

  { Update character set to the new bitmaps }
  setchar('',led1);
  setchar('',led2);
  setchar('',led3);
  setchar('',char1);
  setchar('',char2);
  setchar('',lo);
  setchar('',o);
  setchar('',so);
  setchar('',s1);
  setchar('',ro);
  setchar('',lu);
  setchar('',ru);
  setchar('',su);
  setchar('',u);
  setchar('',sl);
  setchar('',sr);

  cls;
  writexy(13,25,'Take a look at my Website: http://sourcenet.home.pages.de');

  { Init playback options frame }
  frame(4,3,74,10);
  writexy(6,4,'P   : Pause');
  writexy(6,5,#27'/'#26' : Slow seek');
  writexy(6,6,#24'/'#25' : Fast seek');
  writexy(6,7,'ESC : Exit');
  writexy(6,8,'I   : Toggle interpolation');
  writexy(6,9,'-/+ : Volume change');
  writexy(6,10,'[/] : Speed change');
  writexy(6,11,'M   : Mute sound');


  { Put out current playback information }
  driver^.getcapabilities(cap);
  writexy(36,4,cap.cardstring);
  if (driver^.data.flags and snd_stereo <> 0) then st := 'Stereo' else st := 'Mono';
  writexy(36,5,'Frequency : '+inttostr(driver^.data.freq,0)+' Hz, '+st);

  { Init VU frame }
  frame(4,18,29,5);
  if (wave^.data.flags and snd_16bit <> 0) then writexy(6,21,'16 Bit') else writexy(6,21,' 8 Bit');
  if (wave^.data.flags and snd_stereo <> 0) then writexy(13,21,'Stereo') else writexy(13,21,' Mono');
  writexy(20,21,'at '+inttostr(wave^.data.ofreq,1)+' Hz');
  textbackground(black);
  writexy(6,19,'                         ');
  writexy(6,20,'                         ');
  textbackground(black);
  textcolor(white);
  writexy(8,19,'L ');
  writexy(8,20,'R ');

  { Init progress frame }
  frame(35,18,43,5);
  textcolor(white);
  pos := wave^.getsize*wave^.data.samplesize;
  writexy(57,20,'Size    : '+inttostr(pos div 1024,5)+' KB');
  pos := pos div wave^.data.ofreq div wave^.data.samplesize;
  writexy(57,19,'Duration: '+inttostr(pos div 60,2)+':'+inttostr(pos mod 60,2));
  hidecursor;
  vol := 256;
  speed := 1;

  { Start playback }
  wave^.play;

  repeat
    if (sound^.change) then showinfo;

    if keypressed then
    begin
      lch := ch;
      ch := readkey;
      if lch = #0 then
      case ch of
        'H' : wave^.setpos(wave^.getpos+16*1024);
        'P' : wave^.setpos(wave^.getpos-16*1024);
        'M' : wave^.setpos(wave^.getpos+4*1024);
        'K' : wave^.setpos(wave^.getpos-6*1024);
      end else
      case ch of
        'm','M' : begin
                    mute := not mute;
                    wave^.mute(mute);
                  end;
        'p','P' : begin
                    wave^.pause;
                    if (wave^.ispaused) then
                    begin
                      textbackground(black);
                      writexy(10,19,'                   ');
                      writexy(10,20,'                   ');
                      textbackground(blue);
                    end;
                  end;
        'i','I' : begin
                    intpol := not intpol;
                    wave^.setinterpolation(intpol);
                  end;
         '-','+': begin
                    if (ch = '-')and(vol > 3) then dec(vol,4);
                    if (ch = '+')and(vol < 509) then inc(vol,4);
                    sound^.setvolume(0,vol);
                    sound^.setvolume(1,vol);
                  end;
         '[',']': begin
                    if (ch = '[')and(speed > 0.02) then speed := speed-0.005;
                    if (ch = ']')and(speed < 1.95) then speed := speed+0.005;
                    wave^.setspeed(speed);
                  end;
       end;
    end else ch := #1;
  until (ch = #27)or(not wave^.isplaying)and(not wave^.ispaused);
  while keypressed do readkey;

  textmode(3);
  writeln('SoundLib 2 wave player');
  writeln;
  writeln('Get the newest version at http://sourcenet.home.pages.de');
  writeln('Any comments or bug reports? Mail me: stefan.goehler@gmx.de');
  wave^.free;
  s.done;
  sound^.free;
  driver^.free;
end.
